//=============================================================================
// BotzPather.
// Otro de mis tantos intentos de adaptar al Botz en los Waypoints de UT para
// que se muevan como seres humanos, no bots.
// Ademas, es posible para que sirva como stand-by point en una puerta o puente
// levadizo mientras el bot busca un camino complejo para activerlo, si el bot
// decide hacer otra cosa a mitad de camino, deja de ir por el activador.		SUPERB!
//
// For testing purposes, do not modify or redistribute
// Have suggestions? Contact me.
// caco_fff@hotmail.com - Higor at UT99.org
//=============================================================================
class BotzPather expands Pawn;

var Botz MyBot;
var() float MaxDist;
var() float MinDist;
var() float TeleDist;
var float InterpolateSpeed;
var bool bIsMoving;

event PreBeginPlay()
{
	bCanJump = True;
	bCanWalk = True;
	bCanSwim = True;
	bCanFly = False;
	bCanOpenDoors = True;
	bCanDoSpecial = True;
}

function SetTargetTo( actor PathTarget)
{
	local actor Path;

//	MyBot.CostJumpSpots(False);				EEP!, no aun
	Path = FindPathToward( PathTarget);
//	MyBot.CostJumpSpots( True);

	MoveTarget = Path;
	bIsMoving = true;
}

function SetInvFind()
{
	local float Rating;
	local actor Path;

	Inventory = MyBot.Inventory;
//	MyBot.CostJumpSpots(False);
	Path = FindBestInventoryPath( rating, false);
//	MyBot.CostJumpSpots( True);
	Inventory = none;

	MoveTarget = Path;
}


event Tick( float Delta)
{
	if (MoveTarget == none)
		return;
	if (VSize(Location - MyBot.location) > MaxDist)
		return;
	if (VSize(Location - MyBot.location) < MinDist)
		SetInterp( 2.5);
	else
		SetInterp( 1.5);

	if ( DetectedFall() )
		SetLocation(MoveTarget.Location);

	if (MyBot.InRadiusEntity( self) )
	{
		BotNotify();
		if (MoveTarget != none)
			SetInterp( 4);
	}
	InterpolateToward( MoveTarget, Delta);

}

function InterpolateToward( actor PathTarget, float Delta)
{
	local float Dist;
	local float Result;

	Dist = VSize( PathTarget.Location - Location);
	Result = Min(InterpolateSpeed * Delta, Dist);
	SetLocation( Location + Normal( PathTarget.Location - Location) * Result);

	if ( VSize( PathTarget.Location - Location) < 1)
	{
		SetLocation( PathTarget.Location);
		BotNotify();
	}
}

function BotNotify()
{
	bIsMoving = false;
	if ( MoveTarget.IsA('Teleporter') && !IsInState('WaitInTeleporter') )
		GotoState('WaitInTeleporter');


	MoveTarget = none;
//	MyBot.UpdateLeader();
}

function SetInterp( float iFactor)
{
	InterpolateSpeed = MyBot.GroundSpeed * iFactor;
}

function bool DetectedFall()
{
	local vector Vectus;

	Vectus = Location;
	Vectus.Z -= 80;

	return FastTrace( Vectus);
}

state WaitInTeleporter
{
	event EndState() { Enable('Tick'); }

	event Tick(float Delta)
	{
		BotNotify();
		if (MoveTarget == none)
		{
			GotoState('Idle');
			return;
		}
		if ( (MoveTarget.Location == Location) && MoveTarget.IsA('Teleporter') )
			return;
		else if ( !MoveTarget.IsA('Teleporter') )
		{
			Global.Tick(Delta);
			GotoState('Idle');
			return;
		}
		Global.Tick(Delta);
	}
Begin:
	Sleep(0.1);
	if ( VSize(MyBot.Location - Location) > TeleDist )
		Goto('Begin');
	MyBot.StopMoving();
	MyBot.MoveTarget = MoveTarget;
	MyBot.GotoState('ScriptedNav','ToTeleporter');
	Goto('Wait');
Wait:
	Disable('Tick');
	SetLocation(MoveTarget.Location);
}

state Idle
{
}

defaultproperties
{
     MaxDist=300.000000
     MinDist=100.000000
     bCanStrafe=True
     Visibility=0
     ReducedDamageType=All
     Physics=PHYS_Flying
     CollisionRadius=0.000000
     CollisionHeight=0.000000
     bCollideActors=False
     bCollideWorld=False
     bBlockActors=False
     bBlockPlayers=False
     bProjTarget=False
     bRotateToDesired=False
}
